/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "vidcap_options.h"

static int VidcapOptionsDisplayPrivateIndex;

static CompMetadata vidcapOptionsMetadata;

static CompPluginVTable *vidcapPluginVTable = NULL;
CompPluginVTable vidcapOptionsVTable;

#define VIDCAP_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, VidcapOptions, o)
#define VIDCAP_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, VidcapOptions, o)

typedef struct _VidcapOptionsDisplay
{
    int screenPrivateIndex;

    CompOption opt[VidcapDisplayOptionNum];
    vidcapDisplayOptionChangeNotifyProc notify[VidcapDisplayOptionNum];
} VidcapOptionsDisplay;

typedef struct _VidcapOptionsScreen
{
} VidcapOptionsScreen;

CompAction * vidcapGetToggleRecord (CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return &od->opt[VidcapDisplayOptionToggleRecord].value.action;
}

void vidcapSetToggleRecordInitiate (CompDisplay *d, CompActionCallBackProc init)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    od->opt[VidcapDisplayOptionToggleRecord].value.action.initiate = init;
}

void vidcapSetToggleRecordTerminate (CompDisplay *d, CompActionCallBackProc term)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    od->opt[VidcapDisplayOptionToggleRecord].value.action.terminate = term;
}

CompOption * vidcapGetToggleRecordOption (CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return &od->opt[VidcapDisplayOptionToggleRecord];
}

void vidcapSetToggleRecordNotify (CompDisplay *d, vidcapDisplayOptionChangeNotifyProc notify)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    od->notify[VidcapDisplayOptionToggleRecord] = notify;
}

char * vidcapGetDirectory (CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return od->opt[VidcapDisplayOptionDirectory].value.s;
}

CompOption * vidcapGetDirectoryOption (CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return &od->opt[VidcapDisplayOptionDirectory];
}

void vidcapSetDirectoryNotify (CompDisplay *d, vidcapDisplayOptionChangeNotifyProc notify)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    od->notify[VidcapDisplayOptionDirectory] = notify;
}

char * vidcapGetCommand (CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return od->opt[VidcapDisplayOptionCommand].value.s;
}

CompOption * vidcapGetCommandOption (CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return &od->opt[VidcapDisplayOptionCommand];
}

void vidcapSetCommandNotify (CompDisplay *d, vidcapDisplayOptionChangeNotifyProc notify)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    od->notify[VidcapDisplayOptionCommand] = notify;
}

Bool vidcapGetDrawIndicator (CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return od->opt[VidcapDisplayOptionDrawIndicator].value.b;
}

CompOption * vidcapGetDrawIndicatorOption (CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return &od->opt[VidcapDisplayOptionDrawIndicator];
}

void vidcapSetDrawIndicatorNotify (CompDisplay *d, vidcapDisplayOptionChangeNotifyProc notify)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    od->notify[VidcapDisplayOptionDrawIndicator] = notify;
}

CompOption * vidcapGetDisplayOption (CompDisplay *d, VidcapDisplayOptions num)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    return &od->opt[num];
}

static const CompMetadataOptionInfo vidcapOptionsDisplayOptionInfo[] = {
    { "toggle_record", "key", 0, 0, 0 },
    { "directory", "string", 0, 0, 0 },
    { "command", "string", 0, 0, 0 },
    { "draw_indicator", "bool", 0, 0, 0 },
};

static Bool vidcapOptionsSetDisplayOption (CompPlugin *plugin, CompDisplay *d, const char *name, CompOptionValue *value)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    CompOption *o;
    int        index;

    o = compFindOption (od->opt, VidcapDisplayOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case VidcapDisplayOptionToggleRecord:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[VidcapDisplayOptionToggleRecord])
                (*od->notify[VidcapDisplayOptionToggleRecord]) (d, o, VidcapDisplayOptionToggleRecord);
            return TRUE;
        }
        break;
     case VidcapDisplayOptionDirectory:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[VidcapDisplayOptionDirectory])
                (*od->notify[VidcapDisplayOptionDirectory]) (d, o, VidcapDisplayOptionDirectory);
            return TRUE;
        }
        break;
     case VidcapDisplayOptionCommand:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[VidcapDisplayOptionCommand])
                (*od->notify[VidcapDisplayOptionCommand]) (d, o, VidcapDisplayOptionCommand);
            return TRUE;
        }
        break;
     case VidcapDisplayOptionDrawIndicator:
        if (compSetDisplayOption (d, o, value))
        {
            if (od->notify[VidcapDisplayOptionDrawIndicator])
                (*od->notify[VidcapDisplayOptionDrawIndicator]) (d, o, VidcapDisplayOptionDrawIndicator);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * vidcapOptionsGetDisplayOptions (CompPlugin *plugin, CompDisplay *d, int *count)
{
    VIDCAP_OPTIONS_DISPLAY(d);
    if (!od)
    {
        *count = 0;
        return NULL;
    }
    *count = VidcapDisplayOptionNum;
    return od->opt;
}

static Bool vidcapOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    VidcapOptionsScreen *os;
    
    VIDCAP_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(VidcapOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    
    return TRUE;
}

static void vidcapOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    VIDCAP_OPTIONS_SCREEN (s);
    VIDCAP_OPTIONS_DISPLAY (s->display);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool vidcapOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    VidcapOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(VidcapOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[VidcapOptionsDisplayPrivateIndex].ptr = od;

    if (!compInitDisplayOptionsFromMetadata (d, &vidcapOptionsMetadata, vidcapOptionsDisplayOptionInfo, od->opt, VidcapDisplayOptionNum))
    {
        free (od);
        return FALSE;
    }

    return TRUE;
}

static void vidcapOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    VIDCAP_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);

    compFiniDisplayOptions (d, od->opt, VidcapDisplayOptionNum);

    free (od);
    d->base.privates[VidcapOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool vidcapOptionsInit (CompPlugin *p)
{
    VidcapOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (VidcapOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&vidcapOptionsMetadata, "vidcap",vidcapOptionsDisplayOptionInfo, VidcapDisplayOptionNum, 0, 0))
        return FALSE;

    compAddMetadataFromFile (&vidcapOptionsMetadata, "vidcap");
    if (vidcapPluginVTable && vidcapPluginVTable->init)
        return vidcapPluginVTable->init (p);
    return TRUE;
}

static void vidcapOptionsFini (CompPlugin *p)
{
    if (vidcapPluginVTable && vidcapPluginVTable->fini)
        vidcapPluginVTable->fini (p);

    if (VidcapOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (VidcapOptionsDisplayPrivateIndex);

    compFiniMetadata (&vidcapOptionsMetadata);
}

static CompBool vidcapOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) vidcapOptionsInitDisplay,
        (InitPluginObjectProc) vidcapOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void vidcapOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) vidcapOptionsFiniDisplay,
        (FiniPluginObjectProc) vidcapOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool vidcapOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = vidcapOptionsInitObject (p, o);
    if (vidcapPluginVTable->initObject)
        rv &= vidcapPluginVTable->initObject (p, o);
    return rv;
}

static void vidcapOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (vidcapPluginVTable->finiObject)
        vidcapPluginVTable->finiObject (p, o);
    vidcapOptionsFiniObject (p, o);
}

static CompOption * vidcapOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) vidcapOptionsGetDisplayOptions,
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool vidcapOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) vidcapOptionsSetDisplayOption,
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
vidcapOptionsGetMetadata (CompPlugin *plugin)
{
    return &vidcapOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!vidcapPluginVTable)
    {
        vidcapPluginVTable = getCompPluginInfo ();
        memcpy(&vidcapOptionsVTable, vidcapPluginVTable, sizeof(CompPluginVTable));
        vidcapOptionsVTable.getMetadata = vidcapOptionsGetMetadata;
        vidcapOptionsVTable.init = vidcapOptionsInit;
        vidcapOptionsVTable.fini = vidcapOptionsFini;
        vidcapOptionsVTable.initObject = vidcapOptionsInitObjectWrapper;
        vidcapOptionsVTable.finiObject = vidcapOptionsFiniObjectWrapper;
        vidcapOptionsVTable.getObjectOptions = vidcapOptionsGetObjectOptions;
	vidcapOptionsVTable.setObjectOption = vidcapOptionsSetObjectOption;
	
    }
    return &vidcapOptionsVTable;
}

