/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _VIDCAP_OPTIONS_H
#define _VIDCAP_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    VidcapDisplayOptionToggleRecord,
    VidcapDisplayOptionDirectory,
    VidcapDisplayOptionCommand,
    VidcapDisplayOptionDrawIndicator,
    VidcapDisplayOptionNum
} VidcapDisplayOptions;

typedef void (*vidcapDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, VidcapDisplayOptions num);

CompOption *vidcapGetDisplayOption (CompDisplay *d, VidcapDisplayOptions num);

typedef enum
{
    VidcapScreenOptionNum
} VidcapScreenOptions;

typedef void (*vidcapScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, VidcapScreenOptions num);

CompOption *vidcapGetScreenOption (CompScreen *s, VidcapScreenOptions num);

CompAction *     vidcapGetToggleRecord (CompDisplay *d);
void             vidcapSetToggleRecordInitiate (CompDisplay *d, CompActionCallBackProc init);
void             vidcapSetToggleRecordTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     vidcapGetToggleRecordOption (CompDisplay *d);
void             vidcapSetToggleRecordNotify (CompDisplay *d, vidcapDisplayOptionChangeNotifyProc notify);

char *           vidcapGetDirectory (CompDisplay *d);
CompOption *     vidcapGetDirectoryOption (CompDisplay *d);
void             vidcapSetDirectoryNotify (CompDisplay *d, vidcapDisplayOptionChangeNotifyProc notify);

char *           vidcapGetCommand (CompDisplay *d);
CompOption *     vidcapGetCommandOption (CompDisplay *d);
void             vidcapSetCommandNotify (CompDisplay *d, vidcapDisplayOptionChangeNotifyProc notify);

Bool             vidcapGetDrawIndicator (CompDisplay *d);
CompOption *     vidcapGetDrawIndicatorOption (CompDisplay *d);
void             vidcapSetDrawIndicatorNotify (CompDisplay *d, vidcapDisplayOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
